build:api:
  stage: build
  image: docker:stable
  services:
    - docker:dind
  before_script:
    - cd service_api
  script:
    - docker build --build-arg VERSION=${CI_COMMIT_SHORT_SHA} --tag service_api:${CI_COMMIT_SHORT_SHA} .
    - docker tag service_api:${CI_COMMIT_SHORT_SHA} ${CI_REGISTRY_IMAGE}/service_api:${CI_COMMIT_REF_SLUG}-latest
    - docker tag service_api:${CI_COMMIT_SHORT_SHA} ${CI_REGISTRY_IMAGE}/service_api:${CI_COMMIT_REF_SLUG}-${CI_COMMIT_SHORT_SHA}
    - docker login --username ${CI_REGISTRY_USER} --password ${CI_REGISTRY_PASSWORD} ${CI_REGISTRY_IMAGE}
    - docker push ${CI_REGISTRY_IMAGE}/service_api

# test:api:
#   stage: test
#   image: docker:stable
#   variables:
#     NEO4J_PASSWORD: admin
#   services:
#     - docker:dind
#   before_script:
#     - cd service_api
#     - apk add jq wget file python3 py3-pip
#     - ln -sf /usr/bin/python3 /usr/bin/python
#     - python -m pip install openapi-spec-validator
#   script:
#     - docker login --username ${CI_REGISTRY_USER} --password ${CI_REGISTRY_PASSWORD} ${CI_REGISTRY_IMAGE}
#     - docker stop service_api || true
#     - docker network inspect testing || docker network create testing
#     - docker container inspect db || docker run --rm -d --name db --network testing -p 7474:7474 -p 7687:7687 --env NEO4J_AUTH=neo4j/${NEO4J_PASSWORD} neo4j:${NEO4J_VERSION}
#     - docker logs --follow db &
#     - docker run --rm --name load-data --network testing --env NEO4J_USERNAME=neo4j --env NEO4J_PASSWORD=${NEO4J_PASSWORD} --env NEO4J_HOST=db ${CI_REGISTRY_IMAGE}/neo4j_data:${CI_COMMIT_REF_SLUG}-latest
#     - docker run --rm -d --name service_api --network testing -p 8080:8888 --env NEO4J_USERNAME=neo4j --env NEO4J_PASSWORD=${NEO4J_PASSWORD} --env NEO4J_ADDRESS=bolt://db ${CI_REGISTRY_IMAGE}/service_api:${CI_COMMIT_REF_SLUG}-latest
#     - docker logs --follow service_api &
#     - wget -O - http://localhost:8080/info --tries=5 --waitretry=2 | jq -r '.'
#     - wget -O /dev/null http://localhost:8080/db/grammar
#     - wget -qO - http://localhost:8080/db/graph | file - --mime-type | grep 'image/svg+xml'
#     - wget -qO - http://localhost:8080/db/graph?lang=raw | file - --mime-type | grep 'text/plain'
#     - wget -qO - http://localhost:8080/db/graph?lang=png | file - --mime-type | grep 'image/png'
#     - wget -qO - http://localhost:8080/db/graph?lang=pdf | file - --mime-type | grep 'application/pdf'
#     - wget -qO - http://localhost:8080/info/spec | openapi-spec-validator -
#     - kill $(jobs -p)
#   after_script:
#     - docker stop service_api
#     - docker stop db
#   only:
#     changes:
#       - service_api/**/*

deploy:api:portal:
  extends: .ci_deploy_config_master
  script:
    - cd service_api
    - ./generate_kube_config.sh | kubectl apply -f -
    - kubectl delete pod -l app=service-api # force to fetch new image

deploy:api:branch:
  extends:
    - deploy:api:portal
    - .ci_deploy_config_branch
